
 
















function deferredPresent ( )
{
	return cy_deferred;
}


var cy_os = "0";
var cy_submit_lock_in_ms = 2000;
var cy_confirm_exit_lock_in_ms = 5000;
var cy_is_page_submitted = false;
var cy_enter_always_submits = false;
var cy_default_form_to_submit = null;
var cy_close_on_enter=false;
var cy_should_confirm_page_exit = true;
var cy_use_checksum=true;

function CheckAllFieldsInForm (form)
{
	if ( deferredPresent ( ) )
		return DEFER_CheckAllFieldsInForm ( form );
	else
		return true; 
}


function ValidateCharsetRuleList( rule_str , rule_list )
{
	if ( deferredPresent ( ) )
		return DEFER_ValidateCharsetRuleList( rule_str , rule_list );
	else
		return true; 
}

function ValidateCharsetRule ( str , charset , min , max )
{
	if ( deferredPresent ( ) )
		return DEFER_ValidateCharsetRule ( str , charset , min , max );
	else
		return true; 
}

function waitCursor()
{
	document.body.style.cursor='wait';
}

function enterPress (evt)
{
    var char_code = evt.which || evt.keyCode; 
	var who_sent_me = evt.target || evt.srcElement; 
	
    if (char_code == 13) 
    {
 	    clearShouldConfirmPageExit();
 	    if(cy_close_on_enter)
 	    {
 	    	if ( window != null && !window.closed ) window.close();
 	    	return false;
 	    }
 	    if(cy_enter_always_submits)
 	    {
 	      if(who_sent_me.href!=null)return true;
 	      CancelForm(cy_default_form_to_submit);
 	      return false;
 	    }
 	    if(who_sent_me.form == null)return true;
 	    SubmitForm(who_sent_me.form);
 	    return false;
    }
    return true;
}

function clearShouldConfirmPageExit()
{
	cy_should_confirm_page_exit = false;
	setTimeout("cy_should_confirm_page_exit = true;",cy_confirm_exit_lock_in_ms ); 
}

function shouldConfirmPageExit()
{
	return cy_should_confirm_page_exit;
}

function ShouldSubmitForm()
{
  if(cy_is_page_submitted)return false;
  cy_is_page_submitted = true;
  setTimeout("cy_is_page_submitted=false",cy_submit_lock_in_ms);
  clearShouldConfirmPageExit();
  return true;
}

function ShouldSubmit()
{
  return false;
}

function SubmitForm(form_to_submit)
{
  if(form_to_submit==null)return;
  if(!CheckForm(form_to_submit))return;
  if(!ShouldSubmitForm())return;
  BeforeSubmit(form_to_submit);
  waitCursor();
  form_to_submit.submit();
}

function DSubmitForm(form_to_submit, optional_before_submit)
{
  if(form_to_submit==null)return;
  if(!CheckForm(form_to_submit))return;
  if(!ShouldSubmitForm())return;
  optional_before_submit(form_to_submit);
  waitCursor();
  form_to_submit.submit();
}

function CancelForm(form_to_cancel)
{
  if(form_to_cancel==null)return;
  if(!ShouldSubmitForm())return;
  BeforeCancel(form_to_cancel);
  waitCursor();
  form_to_cancel.submit();
}

function DirectSubmitForm(form_to_submit)
{
  if(form_to_submit==null)return;
  if(!ShouldSubmitForm())return;
  waitCursor();
  form_to_submit.submit();
}

function MoveCursor(evt , move_from_field , move_to_field, field_length )
{
  var char_code = evt.which || evt.keyCode;
  if((char_code>47)&&(move_from_field.value.length>=field_length)&& (cy_os != 3))
  {
    move_to_field.focus();
    move_to_field.select();
  }
}

var cy_popup_name = "cy_popup_window";

function JSOpenNewWindow(url,win_name,win_width,win_height,win_left,win_top,props)
{
  clearShouldConfirmPageExit();
  if(win_width!=null)
  {
    props += ",width="+win_width;
  }
  if(win_height!=null)
  {
    props += ",height="+win_height;
  }
  
  if(win_left!=null)
  {
	props += ",left=" + win_left;
  }

  if(win_top!=null)
  {
	props += ",top=" + win_top;
  }
  
  if(props.length > 0 && props.charAt(0) == ',')
  {
  	props = props.substr(1);
  }
  return window.open(url,win_name,props);
}

function JSOpenNewWindow2(url,win_name,win_left,win_top,props)
{
  clearShouldConfirmPageExit();
	
  if(win_left!=null)
  {
	props += ",left=" + win_left;
  }

  if(win_top!=null)
  {
	props += ",top=" + win_top;
  }
  
  if(props.length > 0 && props.charAt(0) == ',')
  {
  	props = props.substr(1);
  }
  return window.open(url,win_name,props);
}

function JSVoidOpenNewWindow2(url,win_name,win_left,win_top,props)
{
	JSOpenNewWindow2 ( url,win_name,win_left,win_top,props );
}

function JSVoidOpenNewWindow(url,win_name,win_width,win_height,win_left,win_top,props)
{
  JSOpenNewWindow(url,win_name,win_width,win_height,win_left,win_top,props);
}

function JSOpenNewDefaultWindow(url,win_name,props)
{
  return JSOpenNewWindow(url,win_name,screen.width*0.75,screen.height*0.75,10,10,props);
}

function JSVoidOpenNewDefaultWindow(url)
{
  JSOpenNewDefaultWindow(url,cy_popup_name,"scrollbars=yes");
}

function JSVoidOpenNewDefaultWindowProps(url,props)
{
  JSOpenNewDefaultWindow(url,cy_popup_name,props);
}

function JSVoidOpenResizableScroll(url)
{
  JSOpenNewDefaultWindow(url,cy_popup_name,"resizable=yes,scrollbars=yes");
}

function JSVoidOpenNewToolbarWindow(url)
{
	JSOpenNewDefaultWindow(url,cy_popup_name,"toolbar=yes,scrollbars=yes");
}

function changePamWithDefault(default_pam)
{
	var selected_login_index = document.receipt.Login.selectedIndex;
	if (selected_login_index == 0) 
		var selected_pam = default_pam;
	else
		var selected_pam = eval('document.pam_list_to_display_without_action.display_pam' + (document.receipt.Login.selectedIndex-1)).value;
	document.all.pam_text.innerHTML = selected_pam;
}

function changePam()
{
	var selected_pam = eval('document.pam_list_to_display_without_action.display_pam' + document.receipt.Login.selectedIndex).value;
	document.all.pam_text.innerHTML = selected_pam;
}

function openFaqWin(url)
{
	faqs_win_var = JSOpenNewWindow(url , cy_popup_name , 780 , 500 , 5 , 5 , "scrollbars=yes" );
}

function rejectPage()
{
	clearShouldConfirmPageExit();
	waitCursor();
	document.reject_form.submit();
}

var ForgotWinP = null;
function ForgotPasswordWindow(url)
{
	var should_open = true;

	if ( (ForgotWinP != null) && (!ForgotWinP.closed) )
	{
		ForgotWinP.focus();
		should_open = false;
	}
	if ( should_open )
	{
		ForgotWinP = JSOpenNewWindow(url , 'ForgotWin' , 440 , 510,15,80,"scrollbars=no");
	}
}

function setFocusFirstElementInForm ( form )
{
	if ( form == null || form.elements == null ) return;
	var current_type;
	for ( i = 0 ; i < form.elements.length ; ++i )
	{
		current_type = form.elements[i].type;
		if ( current_type == "text" || current_type == "password" )
		{
			form.elements[i].focus();
			break;
		}
	}
}

function setFocusFirstEmptyElementInForm ( form )
{
	if ( form == null || form.elements == null ) return;
	var current_type;
	var set_focus_element;
	set_focus_element = null;
	for ( i = 0 ; i < form.elements.length ; ++i )
	{
		current_type = form.elements[i].type;
		if ( current_type == "text" || current_type == "password" || current_type == "select")
		{
			if ( form.elements[i].value == "" )
			{
				set_focus_element = form.elements[i];
				break;
			}
		}
	}
	if ( set_focus_element != null )
		set_focus_element.focus();
}

var hexcase = 0;  
var b64pad  = ""; 
var chrsz   = 8;  


function binl2b64(binarray)
{
  var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i += 3)
  {
    var triplet = (((binarray[i   >> 2] >> 8 * ( i   %4)) & 0xFF) << 16)
                | (((binarray[i+1 >> 2] >> 8 * ((i+1)%4)) & 0xFF) << 8 )
                |  ((binarray[i+2 >> 2] >> 8 * ((i+2)%4)) & 0xFF);
    for(var j = 0; j < 4; j++)
    {
      if(i * 8 + j * 6 > binarray.length * 32) str += b64pad;
      else str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
    }
  }
  return str;
}

function str2binl(str)
{
  var bin = Array();
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < str.length * chrsz; i += chrsz)
    bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (i%32);
  return bin;
}

function getAjaxResponse(url,params,bRetrunXMLResponse)
{
 
 if( typeof (XMLHttpRequest) == "undefined" )
 XMLHttpRequest = function()
  {
    try { return new ActiveXObject("Msxml2.XMLHTTP.6.0"); } catch(e) {};
    try { return new ActiveXObject("Msxml2.XMLHTTP.3.0"); } catch(e) {};
    try { return new ActiveXObject("Msxml2.XMLHTTP"); }     catch(e) {};
    try { return new ActiveXObject("Microsoft.XMLHTTP"); }  catch(e) {};
 
    throw new Error("This browser does not support XMLHttpRequest or XMLHTTP.");
  };
 
  var request =  new XMLHttpRequest();
  request.open("POST", url, false);
  request.setRequestHeader("Content-Type","application/x-www-form-urlencoded;charset=UTF-8");
  request.setRequestHeader("Content-Length", params.length);
  request.setRequestHeader("Connection", "close");
  
 
  
  request.send(params);
  if(bRetrunXMLResponse)
  {
    return (request.responseXML);
  }
  else
  {
    return (request.responseText);
  } 
}


